<template>
  <div class="three fields">
    <div class="field connection">
      <div
        v-for="(connection, index) in connections"
        :key="index"
        class="flexline _fluid"
        :class="{ 'invalid': hasError(index) }">
        <multiselect
          v-model="connection.type"
          class="no-checkbox"
          :class="{'no-opt-as-simple': !notSelectedOptions.length}"
          :disabled="!notSelectedOptions.length"
          :options="notSelectedOptions"
          label="name"
          track-by="id"
          :id="'selectMethod-' + index"
          :allow-empty="false"
          :searchable="false"
          :show-labels="false"
          :preselect-first="false"
          @select="onChangeField('', index)"
          placeholder="-">
          <span slot="noOptions"/>
        </multiselect>
        <div class="ui input">
          <AppField
            :type="'text'"
            :name="'additionalContact'"
            :placeholder="'Контакт'"
            :field="connection"
            :validation-rule="validationRule"
            :revalidate="isSend"
            :class="{ 'invalid': hasError(index) }"
            @has-error="onHasError($event, index)"
            @change-field='onChangeField($event, index)'/>
        </div>
        <button
          @click.stop.prevent="deleteItem(index)"
          class="button-delete"/>
        <div
          class="icon-confirmed"
          v-show="connection.additionalContactIsConfirmed"
          v-tooltip.ios="additionalContactConfirmedTooltip">
          <img
            svg-inline
            src="~/assets/svg/icons/confirmed.svg"
            alt="Контакт подтвержден">
        </div>
        <div
          v-show="!connection.additionalContactIsConfirmed || connection.hasChange"
          v-tooltip.ios="informationTooltip(index, connection)"
          class="phone-information"
          :class="{'_alert': !isUnique(connection)}">
          <img
            svg-inline
            src="~/assets/svg/icons/info.svg"
            alt="иконка информации">
        </div>
        <div
          v-show="connection.error"
          class="error message">
          {{ connection.error }}
        </div>
      </div>

      <button
        v-if="canAdd"
        @click="addItem"
        class="ui button transparent small add-connection">
        + Добавить способ связи
      </button>
    </div>
  </div>
</template>

<script>
import Multiselect from 'vue-multiselect';
import { get } from 'lodash-es';
import AppField from '~/components/redesign/blocks/app-field';

export default {
  name: 'AddConnection',
  components: {
    Multiselect,
    AppField,
  },
  model: {
    prop: 'connections',
    event: 'change',
  },
  props: {
    aditionalContacts: {
      type: Array,
      default: () => [],
    },
    connections: {
      type: Array,
      required: true,
    },
    additionalContactMethodsOptions: {
      type: Array,
      required: true,
    },
    displayType: {
      type: String,
      default: 'shop',
    },
    isSend: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      additionalContactConfirmedTooltip: {
        classes: 'ui popup tooltip visible dark bottom',
        placement: 'right',
        trigger: 'hover',
        offset: '12',
        html: 'true',
        content: `<div style='text-align: center'>
                              Контакт подтвержден
                            </div>`,
      },
      validationRule: {
        isUnique: true,
      },
    };
  },
  computed: {
    notSelectedOptions() {
      const selectedOptions = this.connections
        .map(contact => contact.type && contact.type.name)
          || [];

      return this.additionalContactMethodsOptions
        .filter(option => option && !selectedOptions.includes(option.name))
          || [];
    },
    canAdd() {
      return this.connections.length < this.additionalContactMethodsOptions.length;
    },
  },
  mounted() {
    if (this.aditionalContacts.length) {
      const itemsTypesCodes = {};
      this.additionalContactMethodsOptions.forEach((obj) => { itemsTypesCodes[obj.code] = obj.id; });

      const items = this.aditionalContacts.map(obj => ({
        contactId: obj.id,
        name: obj.contact,
        additionalContactIsConfirmed: obj.additionalContactIsConfirmed,
        type: {
          code: obj.contactType.code,
          id: itemsTypesCodes[obj.contactType.code],
          name: obj.contactType.name,
        },
      }));
      this.$emit('change', items);
    }
  },
  methods: {
    hasError(index) {
      return this.connections.some((item, i) => i === index && item.error);
    },
    addItem() {
      const newItem = this.connections;
      let connectionType = null;

      if (this.notSelectedOptions.length === 1) {
        connectionType = this.notSelectedOptions[0];
      }

      newItem.push({
        contactId: null,
        hasChange: false,
        type: connectionType,
        name: null,
      });
      this.$emit('change', newItem);
    },
    deleteItem(index) {
      const newItem = this.connections;
      newItem.splice(index, 1);
      this.$emit('change', newItem);
    },
    informationTooltip(index, connection) {
      const type = get(this.aditionalContacts[index], 'contactType.name', '');
      const content = this.isUnique(connection)
        ? `Подтверждение ${type} возможно через вашего менеджера или по телефону: ${this.$config.contacts.info.phone}`
        : `Свяжитесь с вашим менеджером или по телефону ${this.$config.contacts.info.phone}`;

      return {
        classes: 'ui popup tooltip visible dark bottom',
        placement: 'right',
        trigger: 'hover',
        offset: '12',
        html: 'true',
        content: `<div style='text-align: center'>${content}</div>`,
      };
    },
    onChangeField(value, index) {
      this.$emit('change-additional-contact', { value, index });
    },
    onHasError(error, index) {
      this.$emit('has-error', { error, index });
    },
    isUnique(connection) {
      // TODO: Workaround для проверки ошибки уникальности
      return connection.error !== 'Контакт уже используется';
    },
  },
};
</script>

<style scoped lang="scss">
  .flexline {
    display: flex;
    flex-flow: row wrap;
    justify-content: space-between;
    align-items: center;
    margin-bottom: 0.875rem;

    &._fluid {
      position: relative;
      width: 100%;
    }

    &.invalid {
      position: relative;
      padding-bottom: 1.6rem;
    }
  }

  .button-delete {
    flex: 1 0 2rem;
    display: block;
    width: 2rem;
    height: 2rem;
    outline: none;
    border: none;
    box-shadow: none;
    border-radius: 0.25rem;
    background-color: #728896;
    background-position: center;
    background-repeat: no-repeat;
    background-size: 0.8125rem auto;
    background-image: url('data:image/svg+xml;base64,PD94bWwgdmVyc2lvbj0iMS4wIiBlbmNvZGluZz0idXRmLTgiPz4KPHN2ZyBjbGFzcz0ic3ZnLWZpbGwiIGZpbGw9IiNmZmZmZmYiIHhtbG5zPSJodHRwOi8vd3d3LnczLm9yZy8yMDAwL3N2ZyIgeG1sbnM6eGxpbms9Imh0dHA6Ly93d3cudzMub3JnLzE5OTkveGxpbmsiIHg9IjBweCIgeT0iMHB4IgoJIHZpZXdCb3g9IjAgMCAxMiAxNCIgc3R5bGU9ImVuYWJsZS1iYWNrZ3JvdW5kOm5ldyAwIDAgMTIgMTQ7IiB4bWw6c3BhY2U9InByZXNlcnZlIj4KCjxyZWN0IHg9IjciIHk9IjUiIHdpZHRoPSIxIiBoZWlnaHQ9IjYiLz4KPHJlY3QgeD0iNCIgeT0iNSIgd2lkdGg9IjEiIGhlaWdodD0iNiIvPgo8cGF0aCBkPSJNMTIsMkg4LjVWMS41QzguNiwwLjcsOCwwLjEsNy4yLDBINC44QzQsMC4xLDMuNCwwLjcsMy41LDEuNVYySDB2MWgxdjguNUMxLDEyLjksMi4xLDE0LDMuNSwxNAoJaDVjMS40LDAsMi41LTEuMSwyLjUtMi41VjNoMVYyeiBNNC41LDEuNUM0LjUsMS4yLDQuNywxLDQuOCwxaDIuNGMwLjEsMCwwLjMsMC4yLDAuMywwLjVWMmgtM1YxLjV6IE0xMCwxMS41YzAsMC44LTAuNywxLjUtMS41LDEuNQoJaC01QzIuNywxMywyLDEyLjMsMiwxMS41VjNoOFYxMS41eiIvPgo8L3N2Zz4K');
    cursor: pointer;
    transition: 0.1s ease background-color;
    &:hover {
      background-color: #345A81;
    }
  }

  .ui.button.add-connection {
    width: auto;
    margin: 0 auto 0 0;
  }

  .field.connection {
    display: flex;
    flex-flow: column nowrap;
    padding-top: 0.5rem;
    width: 44.8% !important;
    .ui.input, .multiselect {
      width: calc((100% - 2rem - 1.75rem) / 2) !important;
      margin-right: 0.875rem;
      flex-shrink: 0;
    }
  }

  .icon-confirmed {
    position: absolute;
    right: -40px;
    display: flex;
  }

  .phone-information {
    position: absolute;
    right: -40px;
    height: 25px;

    & > svg {
      width: 24px;
      height: 25px;
      fill: #669ED9;
    }

    &._alert {
      & > svg {
        fill: #e13c3c;
      }
    }
  }

  .error.message {
    position: absolute;
    bottom: 0;
    left: 0;
  }
</style>
